//---------------------------------------------------------------------------
// (c)Alex A. Trubetskoy            alextr438@yandex.ru
//---------------------------------------------------------------------------
#define STRICT
#include <windows.h>
#include <stdlib.h>
#pragma hdrstop
#include "SemUnit.h"
#include "Semaphore.rh"
//---------------------------------------------------------------------------
const char szMainClassName[] = "SemMainAppClass";
const char szWindowTitle[] = "Semaphore Application";
HINSTANCE hInst;
HWND hwndMain;

HANDLE hSemaphore;
const char lpSemaphoreName[] = "MySemaphore";

//  
const unsigned countThreads = 3;
HANDLE hThreads[countThreads];
//---------------------------------------------------------------------------
int PASCAL
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpszCmdLine, int nCmdShow)
{
    MSG msg;
    hInst = hInstance;
    if(!InitApp(hInstance))
        return FALSE;
        
    //  
    hSemaphore = CreateSemaphore(NULL, 1, 1, lpSemaphoreName);
    if(hSemaphore == NULL) {
        MessageBox(NULL, "   ", szWindowTitle,
                    MB_ICONSTOP);
        return FALSE;
    }

    hwndMain = CreateWindow(szMainClassName, szWindowTitle,
                WS_DLGFRAME | WS_SYSMENU,
                140, 80, 550, 400, 0, 0, hInstance, NULL);
    if(!hwndMain)
        return FALSE;
    ShowWindow(hwndMain, nCmdShow);
    UpdateWindow(hwndMain);
    CreateWindow("button", "Paint", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                20, 320, 90, 30, hwndMain, (HMENU)BTN_PAINT, hInstance, NULL);
    while(GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    CloseHandle(hSemaphore);
    return msg.wParam;
}
//---------------------------------------------------------------------------
BOOL
InitApp(HINSTANCE hInstance)  {
    ATOM aWndClass;
    WNDCLASS wc;

    memset(&wc, 0, sizeof(wc));
    wc.style         = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc   = (WNDPROC)MainWndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(ICON_SEM));
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)COLOR_WINDOW;
    wc.lpszMenuName  = (LPSTR)NULL;
    wc.lpszClassName = (LPSTR)szMainClassName;

    aWndClass = RegisterClass(&wc);
    return (aWndClass != 0);
}
//---------------------------------------------------------------------------
LRESULT CALLBACK _export
MainWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    DWORD dwIdThread;
    switch (msg) {
        case WM_COMMAND: {
            if(wParam == BTN_PAINT) {
                for(int i = 0; i < countThreads; ++i) {
                    hThreads[i] = CreateThread(NULL, 0,
                                (LPTHREAD_START_ROUTINE)threadRoutine,
                                (LPVOID)&hwndMain, 0, (LPDWORD)&dwIdThread);
                    if(hThreads[i] == NULL) {
                        MessageBox(NULL, "   ",
                                szWindowTitle, MB_ICONSTOP);
                    }
                    else
                        CloseHandle(hThreads[i]);
                }
            }
            return 0;
        }
        case WM_DESTROY: {
            PostQuitMessage(0);
            return 0;
        }
    }
    return DefWindowProc(hwnd, msg, wParam, lParam);
}
//---------------------------------------------------------------------------
DWORD threadRoutine(HWND* phWnd)
{
    //   
    if(WaitForSingleObject(hSemaphore, 30000) == WAIT_FAILED)
        return 0;

    //  
    HDC hDC = GetDC(*phWnd);
    HBRUSH hBrush, hOldBrush;
    randomize();
    int color = rand() % 7;
    switch(color) {
        case 0: hBrush = CreateSolidBrush(RGB(0, 0, 255)); break;
        case 1: hBrush = CreateSolidBrush(RGB(0, 255, 0)); break;
        case 2: hBrush = CreateSolidBrush(RGB(255, 0, 0)); break;
        case 3: hBrush = CreateSolidBrush(RGB(0, 255, 255)); break;
        case 4: hBrush = CreateSolidBrush(RGB(255, 255, 0)); break;
        case 5: hBrush = CreateSolidBrush(RGB(255, 0, 255)); break;
        case 6: hBrush = CreateSolidBrush(RGB(255, 255, 255)); break;
    }
    hOldBrush = (HBRUSH)SelectObject(hDC, hBrush);
    Rectangle(hDC, 20, 20, 320, 220);
    SelectObject(hDC, hOldBrush);
    DeleteObject(hBrush);
    ReleaseDC(*phWnd, hDC);
    UpdateWindow(*phWnd);
    Sleep(1000);

    //     ,   
    //    
    if(hSemaphore != NULL)
        ReleaseSemaphore(hSemaphore, 1, NULL);
    return 0;
}
//---------------------------------------------------------------------------



